=== debian/changelog ===
springlobby (0.273-2build1) lunar; urgency=medium

  * No-change rebuild against wxwidgets 3.2.1

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 20 Jan 2023 13:37:43 +0000

springlobby (0.273-2) unstable; urgency=medium

  * Team upload.
  * Transition to wxWidgets 3.2 (Closes: #1019792)

 -- Scott Talbert <swt@techie.net>  Tue, 01 Nov 2022 16:31:26 -0400

springlobby (0.273-1) unstable; urgency=medium

  * New upstream version 0.273.
  * Declare compliance with Debian Policy 4.6.0.
  * Drop libjsoncpp.patch. Fixed upstream.

 -- Markus Koschany <apo@debian.org>  Tue, 24 Aug 2021 02:37:26 +0200
